path = File.expand_path(File.dirname(__FILE__))
$:.unshift(path) unless $:.include?(path)
require "fake_csv/version"
require "fake_csv/format"
require "fake_csv/readfile"
require "fake_csv/writefile"
require "fake_csv/g_data"

class Fake
    # extend self
    attr_accessor :readfile, :writefile

    def initialize
        @readfile = Readfile.new
    end

    def read_file(file_name)
        @readfile.read(file_name)
    end

    def header(header)
        @readfile.header = header
    end

    def format(time, format)
        time = "(" + time.to_s + ")"
        @readfile.format.store(@readfile.format.length+1, :format=>time, :content=>format)
    end

    def generate_file(folder, filename)
        writefile = Writefile.new(@readfile.header, folder, filename)
        g_data = GenerateData.new
        g_data.generate(@readfile.format)
        writefile.file(g_data.data)
    end
end

# fake = Fake.new
# fake.header("x1,x2")
# fake.format(20, '["come on" "yo" "hi"]')
# fake.generate_file